#
# PFindF - index.fet Ƥ⥸塼
# Copyright (C) 2001-2006 mxproject <naoh@mxpj.net>
#
# $Id: PFindF.pm 32 2006-05-18 17:13:45Z naoh $
#
# 2006/02/28  3.00  FindF ʬ⥸塼벽
#                   轵 W  W  findfc ˹碌 0:6:ڤѹ
#
# Require: Digest::MD5 (MD5 νϤɬפȤ)
#
# ToDo: Ȥ˥оΥեΥեܸ̾ä
#       ưˤĤƳǧ
#
# Usage:
#   my $findf = new PFindF;
#   $findf->setFormatLevel(PFINDF_PWS200);
#   $findf->addDataSet('foo');
#   $findf->addDataSet('hoge\\moge');
#   $findf->addNextUpdate(PFINDF_DATE, 12, 34, 2006, 8, 15); # 2006/8/15 12:34
#   $findf->addNextUpdate(PFINDF_WEEKLY, 9, 0, 5); # 轵 9:00
#   $findf->addNextUpdate(PFINDF_MONTHLY, 2, 9, 29); # 29 2:09
#   $findf->find('path/to/fetch');
#   print $findf->to_string;
#
package PFindF;
use strict;
use vars qw($VERSION $DEBUG $NOMD5);

$VERSION = '3.00 ($Rev: 32 $)';
$DEBUG = 1;
$NOMD5 = 0;

use Exporter;
use vars qw(@ISA @EXPORT);
@ISA = qw(Exporter);
@EXPORT = qw(PFINDF_DATE PFINDF_WEEKLY PFINDF_MONTHLY
			 PFINDF_PWS092 PFINDF_PWS100 PFINDF_PWS200);

sub PFINDF_DATE    { 0 }
sub PFINDF_WEEKLY  { 1 }
sub PFINDF_MONTHLY { 2 }

sub PFINDF_PWS092 {  9200 }
sub PFINDF_PWS100 { 10000 }
sub PFINDF_PWS200 { 20000 }

eval {
	require Digest::MD5;
};
$NOMD5 = 1 if($@);

# 󥹥ȥ饯
sub new
{
	my $class = shift;
	my $self = {
		# ϥեޥåȤεƥ٥
		'format_level' => PFINDF_PWS200,
		# DataSet ꥹȤؤΥե
		'r_datasets' => undef,
		# NextUpdate ꥹȤؤΥե
		'r_nextupdates' => undef,
		# եꥹȤؤΥե
		'r_files' => undef,
		# å
		'target_dir' => undef,
	};

	@{$self->{'r_datasets'}} = ();
	@{$self->{'r_nextupdates'}} = ();
	@{$self->{'r_files'}} = ();

	bless $self, $class;
}

# ϥեޥåȤεƥ٥ꤹ
# 1.00 ʹ: DataSet, NextUpdate  w/m
# 2.00 ʹ: md5 
sub setFormatLevel
{
	my $self = shift;
	$self->{'format_level'} = shift || PFINDF_PWS092;
	return $self;
}

# ǡåȤɲä
# NOTE: ǡåȤ PWS1.00 ʹ
sub addDataSet
{
	my $self = shift;
	my $path = shift;

	push(@{$self->{'r_datasets'}}, $path);

	return $self;
}

# FIXME: եޥåȤǤ WEEKLY/MONTHLY Բ
sub addNextUpdate
{
	my $self = shift;
	my $style = shift;

	my $hour  = shift || 0;
	my $min   = shift || 0;

	if($style == PFINDF_DATE)
	{
		# Y ǯ M  D   h  m ʬ
		push(@{$self->{'r_nextupdates'}}, {
			'type'  => PFINDF_DATE,
			'year'  => shift || 1970,
			'month' => shift || 1,
			'date'  => shift || 1,
			'hour'  => $hour,
			'min'   => $min,
		});
	}
	elsif($style == PFINDF_WEEKLY)
	{
		# 轵 W   h  m ʬ
		push(@{$self->{'r_nextupdates'}}, {
			'type'  => PFINDF_WEEKLY,
			'wday'  => shift || 0,
			'hour'  => $hour,
			'min'   => $min,
		});
	}
	elsif($style == PFINDF_MONTHLY)
	{
		#  D   h  m ʬ
		push(@{$self->{'r_nextupdates'}}, {
			'type'  => PFINDF_MONTHLY,
			'date'  => shift || 1,
			'hour'  => $hour,
			'min'   => $min,
		});
	}

	return $self;
}

# ǥ쥯ȥ
# find  setFormatLevel  PWS2.00 ꤷ
# md5 Ϸ׻ʤ
sub find
{
	my $self = shift;
	my $basedir = shift;

	@{$self->{'r_files'}} = ();
	$self->{'target_dir'} = $basedir;

	return $self->_findDir;
}

sub _findDir
{
	my $self = shift;

	my $curdir = shift || '.';  # target_dir Хѥ
	my $path_level = shift || 0;
	my $last_modified = shift || 0;

	opendir(DH, $self->{'target_dir'}.'/'.$curdir) or die "Can't open directory\n";
	foreach(readdir(DH))
	{
		# ".*", "*.fet" ɲäʤ
		next if(/(?:^(\.)|\.fet$)/);

		my $name = $_;
		my $fullpath = $self->{'target_dir'}.'/'.$curdir.'/'.$name;

		my @st = stat($fullpath);

		if($last_modified < $st[9])
		{
			$last_modified = $st[9];
		}

		my $attr, my $size, my $hash = 0;
		if(-f $fullpath)
		{
			$attr = 'f';
			$size = $st[7];
			$hash = 0;
			if($NOMD5 == 0 && $self->{'format_level'} >= PFINDF_PWS200)
			{
				open(FH, $fullpath) or die "Can't open $fullpath: $!\n";
				binmode(FH);

				my $md5 = Digest::MD5->new;
				$md5->addfile(*FH);
				$hash = $md5->hexdigest;

				close(FH) or die "Can't close $fullpath: $!\n";
			}
		}
		else
		{
			$attr = 'd';
			$size = 0;
			$hash = 0;
		}

		my $fileinfo = {
			'md5'   => $hash,        # md5 hash
			'date'  => $st[9],       # modified time
			'attr'  => $attr,        # d (directory) or f (file)
			'bsize' => $st[7],       # bytes
			'path'  => $curdir,      # path
			'level' => $path_level,  # path level (0-)
			'name'  => $name,        # file name
		};
		push(@{$self->{'r_files'}}, $fileinfo);

		# ֥ǥ쥯ȥ
		if($attr eq 'd')
		{
			$last_modified = $self->_findDir($curdir.'/'.$name,
				$path_level+1, $last_modified);
		}
	}
	closedir(DH);

	return $last_modified;
}

# index.fet Ƥ
sub to_string
{
	my $self = shift;

	my $buf = '';

	# 󹹿
	my @updates = ();
	foreach(@{$self->{'r_nextupdates'}})
	{
		my $r_up = $_;

		next if($r_up->{'type'} != PFINDF_DATE &&
				$self->{'format_level'} < PFINDF_PWS100);

		if($r_up->{'type'} == PFINDF_DATE)
		{
			push(@updates, sprintf("%d %d %d %d %d",
				$r_up->{'year'}, $r_up->{'month'}, $r_up->{'date'},
				$r_up->{'hour'}, $r_up->{'min'}));
		}
		elsif($r_up->{'type'} == PFINDF_WEEKLY)
		{
			push(@updates, sprintf("w %d %d %d",
				$r_up->{'wday'}+1, $r_up->{'hour'}, $r_up->{'min'}));
		}
		elsif($r_up->{'type'} == PFINDF_MONTHLY)
		{
			push(@updates, sprintf("m %d %d %d",
				$r_up->{'date'}, $r_up->{'hour'}, $r_up->{'min'}));
		}
	}
	$buf .= "#NextUpdate ".join(',', @updates)."\r\n";

	# եɾ
	if($self->{'format_level'} >= PFINDF_PWS200)
	{
		$buf .= "#FieldInfo md5 32 attr 1 bsize 10\r\n";
	}
	else
	{
		$buf .= "#FieldInfo date 12 attr 1 size 5\r\n";
	}

	foreach(@{$self->{'r_files'}})
	{
		my $r_file = $_;

		if($r_file->{'attr'} eq 'd' &&
		   $self->{'format_level'} >= PFINDF_PWS100)
		{
			# ǡåȻ꤬뤫å
			my $npath = $r_file->{'path'};
			$npath =~ s/^\.\/?//;
			if($npath ne '')
			{
				$npath =~ s/\//\\/;
				$npath .= "\\";
			}
			$npath .= $r_file->{'name'};

			foreach(@{$self->{'r_datasets'}})
			{
				if($_ eq $npath)
				{
					$buf .= "#DataSet ".$_."\r\n";
					last;
				}
			}
		}

		# եν
		if($NOMD5 == 0 && $self->{'format_level'} >= PFINDF_PWS200)
		{
			$buf .= sprintf("%032s%s%010d",
				$r_file->{'md5'}, $r_file->{'attr'}, $r_file->{'bsize'});
		}
		else
		{
			#  GMT
			my @t = gmtime($r_file->{'date'});

			$buf .= sprintf("%4d%02d%02d%02d%02d%s%05d",
				$t[5]+1900, $t[4]+1, $t[3], $t[2], $t[1],
				$r_file->{'attr'}, int($r_file->{'bsize'}/1024));
		}
		$buf .= '|' x $r_file->{'level'} . '+' . $r_file->{'name'} . "\r\n";
	}

	return $buf;
}

sub _error
{
	my $msg = shift;
	print '#ERROR:'.$msg if($DEBUG >= 1);
	exit;
}

1;
__END__
